/*
The following 2 variables can be changed to whatever values are desired. The 
script will automatically calculate the resistor value and print it in the console (it's recommended that 
a potentiometer is used to precisely set the cutoff frequency). Measure the 
capacitor's true value with a multimeter for more accurate modeling.
*/

var C = 11*Math.pow(10,-9) //set the capacitance in Farads (default = 11nF)
var fC = 50000 //set the cutoff frequency in Hz (default = 50kHz)

Scope1.run()
Wavegen1.run()
wait(2)
var startFreq = Wavegen1.Channel1.Sweep.Frequency.Start.value
var stopFreq = Wavegen1.Channel1.Sweep.Frequency.Stop.value
var sweepTime = Wavegen1.Channel1.Sweep.Frequency.Time.value
channel1 = Scope1.Channel1
sweepData = channel1.data
Scope1.Ref1.Clone(Scope1.Channel1)
Scope1.Ref1.enable = true
Scope1.Ref2.Clone(Scope1.Channel1)
Scope1.Ref2.enable = true
var R = 1/(2*Math.PI*fC*C)
print("For a passive low-pass RC filter with a cutoff frequency of " + fC + " and a " + C*1000 + " micro-farad capacitor, use a potentiometer set to " + R + " ohms.")
var vOUT = []
var vOUT2 = []

for(var i = 0; i < sweepData.length;i++){
	var t = channel1.TimeOfIndex(i)
	var frequency = (stopFreq - startFreq)/(sweepTime)*t + startFreq
	xC = 1/(2*Math.PI*frequency*C)
	vIN = sweepData[i]
	var tD = t + Math.atan(2*Math.PI*frequency*C*R)/(2*Math.PI*frequency)
	vOUT[Math.round(channel1.IndexOfTime(tD))] = vIN * xC/(Math.sqrt(Math.pow(R,2) + Math.pow(xC,2)))
}
Scope1.Ref1.data = vOUT
Scope1.Ref2.data = vOUT2
Scope1.stop()